UNIT CRTruzne;
{ c Petr Mikulk - Brno - 1991 }
{$G-,R-,S+,V-,E-,N-,D-,L-}

INTERFACE
uses crt, dos, DefFloat;

const CR=#$D; LF=#$A; CRLF=CR+LF;
const CrtRuzneEng: boolean = false;    { false for Czech, true for English }

procedure RightJust ( S: string );

function UpString( S: string ): string;

procedure StandP (var P); (****************)

procedure wr;
procedure re;

procedure rc (var C: char);
procedure rs (var SS: string);

procedure Brn (var A: byte);
procedure Irn (var A: integer);
procedure Rrn (var A: real);
procedure Frn (var A: float);

procedure BStNova (var A: byte);
procedure IStNova (var A: integer);
procedure RStNova (var A: real);
procedure FStNova (var A: float);

procedure Centruj ( S: string );
procedure VyberSi( var C: char );
procedure Press;

function HitESC: boolean;

procedure BakRename ( var SInp,SOut: PathStr );
{ SInp priradi starou verzi (.BAK), SOut priradi puvodni (.typ) }


IMPLEMENTATION

var S: string; P: integer;
const CZold='Star hodnota: '; CZnew=', nov hodnota: ';
      Engold='Old value: '; Engnew=', new value: ';

procedure wr; begin TextBackground(blue); TextColor(yellow) end;

procedure re; begin TextBackground(red) end;

procedure rc (var C: char);
var X,Y,I: integer; S: string[5];
begin re; S[1]:=#0; X:=WhereX; Y:=WhereY;
repeat read(S);
if length(S)>1 then begin GotoXY(X,Y); for I:=1 to length(S) do
  write(' '); wr; re;
  GotoXY(X,Y); sound(440); delay(20); readln; nosound end;
until length(S)<=1;
C:=S[1]; wr; readln;
{ writeln('Press a key..'); repeat until keypressed; readkey; }
end;

procedure rs (var SS: string);
begin re; readln(SS); wr end;

procedure Brn (var A: byte); var AA: byte;
begin re; readln(S); wr; val(S,AA,P);
if length(S)<>0 then { pokud se mu to odesle, tak zustava puvodni hodnota}
   if P<>0 then A:=0 {chyba} else A:=AA end;

procedure Irn (var A: integer); var AA: integer;
begin re; readln(S); wr; val(S,AA,P);
if length(S)<>0 then { pokud se mu to odesle, tak zustava puvodni hodnota}
   if P<>0 then A:=0 {chyba} else A:=AA end;

procedure Rrn (var A: real); var AA: real;
begin re; readln(S); wr; val(S,AA,P);
if length(S)<>0 then { pokud se mu to odesle, tak zustava puvodni hodnota}
   if P<>0 then A:=0 {chyba} else A:=AA end;

procedure Frn (var A: float); var AA: float;
begin re; readln(S); wr; val(S,AA,P);
if length(S)<>0 then { pokud se mu to odesle, tak zustava puvodni hodnota}
   if P<>0 then A:=0 {chyba} else A:=AA end;

procedure BStNova (var A: byte);
begin if CrtRuzneEng then write(EngOld,A:1,Engnew)
else write(CZold,A:1,CZnew); Brn(A) end;

procedure IStNova (var A: integer);
begin if CrtRuzneEng then write(EngOld,A:1,Engnew)
else write(CZold,A:1,CZnew); Irn(A) end;

procedure RStNova (var A: real);
begin if CrtRuzneEng then write(EngOld,A:1,Engnew)
else write(CZold,A:1,CZnew); Rrn(A) end;

procedure FStNova (var A: float);
begin if CrtRuzneEng then write(EngOld,A:1,Engnew)
else write(CZold,A:1,CZnew); Frn(A) end;

procedure Centruj( S: string );
begin GotoXY( (81-length(S)) div 2, WhereY ); writeln(S) end;

procedure VyberSi( var C: char );
begin if CrtRuzneEng then write(LF,'Your choice: ')
else write(LF,'Co sis vybral: '); rc(C); C:=UpCase(C) end;

procedure Press; var Co: char;
begin re; if CrtRuzneEng then write('Press any key...')
else write('Stiskem pokrauj...'); delay(100); wr; repeat until KeyPressed; DelLine; write(CR); Co:=ReadKey end;

function HitESC: boolean;
begin
HitESC:=false; if KeyPressed then if ReadKey=#27 then HitESC:=true
end;

procedure RightJust ( S: string );
begin gotoXY(80-length(S),WhereY ); writeln(S) end;

function UpString ( S: string ): string;    var I: integer;
begin
for I:=1 to length(S) do S[I]:=UpCase(S[I]); UpString:=S
end;

procedure StandP (var P);
{ Prevedeni ukazatele na standardizovany tvar, tj. ofset musi byt 0..15:
  napr. FFF0:0101 je standardne 0000:0001.
  Nestandardizovany tvar vznika pri aritmetickych operacich s pointery,
  nacez pak nesouhlasi srovnavani stejnych pointeru ale s ruznymi tvary     }

type Ukaz = record Ofs,Seg: Word end;
begin
  Ukaz(P).Seg:=Ukaz(P).Seg + (Ukaz(P).Ofs shr 4);
  Ukaz(P).Ofs:=Ukaz(P).Ofs and $000F
end;

procedure BakRename ( var SInp,SOut: PathStr );
{ SInp priradi starou verzi (.BAK), SOut priradi puvodni (.typ) }
var F: text; P: byte;
    Jmeno,Typ,Bak: PathStr;
begin
P:=pos('.',SInp); Jmeno:=Copy(SInp,1,P-1); Typ:=Copy(SInp,P+1,length(SInp)-P);
Bak:=Jmeno+'.bak'; assign(F,Bak);
{$I-} reset(F); if IOresult=0 then begin close(F); erase(F) end
                                   {else close(F)};
{$I+}
assign(F,SInp);
reset(F);
rename(F,Bak);
SOut:=SInp; SInp:=Bak
end;

end. { CRTruzne }
